ghc-lib-parser-9.10.1.20250103: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Types.CompleteMatch

Description

COMPLETE signature

Synopsis

- data CompleteMatch = CompleteMatch {
  - cmConLikes :: UniqDSet ConLike
  - cmResultTyCon :: Maybe TyCon
  }
- vanillaCompleteMatch :: UniqDSet ConLike -> CompleteMatch
- type CompleteMatches = [CompleteMatch]
- completeMatchAppliesAtType :: Type -> CompleteMatch -> Bool

# Documentation

data CompleteMatch #

A list of conlikes which represents a complete pattern match. These arise from `COMPLETE` signatures. See also Note [Implementation of COMPLETE pragmas].

Constructors

CompleteMatch |
Fields cmConLikes :: UniqDSet ConLike The set of `ConLike` values cmResultTyCon :: Maybe TyCon The optional, concrete result TyCon the set applies to

#### Instances

Instances details

Outputable CompleteMatch # |
Instance details Defined in GHC.Types.CompleteMatch Methods ppr :: CompleteMatch -> SDoc #

vanillaCompleteMatch :: UniqDSet ConLike -> CompleteMatch #

type CompleteMatches = [CompleteMatch] #

completeMatchAppliesAtType :: Type -> CompleteMatch -> Bool #